Subject: Re: [PATCH] veth: Cleanly handle a missing peer_tb argument on creation.

From: Pavel Emelyanov <[email-masked]>
Date: Wed, 12 Sep 2007 18:49:08 +0400

Eric W. Biederman wrote:
> Pavel Emelyanov <[email-masked]> writes:
> 
>>> +	}
>>>  
>>> -		tbp = peer_tb;
>>> -	} else
>>> -		tbp = tb;
>> The intention of this part was to get the same parameters for
>> peer as for the first device if no "peer" argument was specified
>> for ip utility. Does it still work?
> 
> I know it is problematic because we try to assign the same name
> to both network devices, if we assign a name to the primary
> network device.  That can't work.

This can - as you can see I reallocate the name lower.

> Beyond that I had some really weird crashes while testing this
> piece of code, especially when I did not specify a peer parameter.

Can you please give me the exact command that caused an oops.
I try simple ip link add type veth and everything is just fine.

> So it was just easier to avoid the problem with this patch then
> to completely root cause it.

Let me handle this problem. AFAIR this was one of wishes from 
Patrick that we make two equal devices in case peer is not given, 
not just the default peer.

> I think the easiest semantic is to not have any peer parameters
> if they were not specified, then to try and to figure out which
> subset of parameters to copy.  If I hadn't been getting weird
> kernel crashes I would not have cared.
> 
> Eric
> 

Thanks,
Pavel